
#include <Wire.h>
#include <Adafruit_AMG88xx.h>
#include <Servo.h>
#define Lpwm_pin  5     //pin of controlling speed---- ENA of motor driver board
#define Rpwm_pin  6    //pin of controlling speed---- ENB of motor driver board
int pinLB=2;             //pin of controlling turning---- IN1 of motor driver board
int pinLF=4;             //pin of controlling turning---- IN2 of motor driver board
int pinRB=7;            //pin of controlling turning---- IN3 of motor driver board
int pinRF=8; 

Servo myservo;
int pos = 0; 

Adafruit_AMG88xx amg;
float pixels[AMG88xx_PIXEL_ARRAY_SIZE];

void setup() {

  pinMode(pinLB,OUTPUT); // /pin 2
  pinMode(pinLF,OUTPUT); // pin 4
  pinMode(pinRB,OUTPUT); // pin 7
  pinMode(pinRF,OUTPUT);  // pin 8
  pinMode(Lpwm_pin,OUTPUT);  // pin 5 (PWM) 
  pinMode(Rpwm_pin,OUTPUT);

  Serial.begin(9600);
  myservo.attach(A2);

  Serial.println(F("AMG88xx pixels"));

  bool status;
  
  // default settings
  status = amg.begin();
  if (!status) {
      Serial.println("Could not find a valid AMG88xx sensor, check wiring!");
      while (1);
  }
  
  Serial.println("-- Pixels Test --");

  Serial.println();

  delay(100); // let sensor boot up

    

}



void go_forward(unsigned char speed_val)    // speed_val：0~255
    {digitalWrite(pinRB,HIGH); 
     digitalWrite(pinRF,LOW);
     digitalWrite(pinLB,HIGH);
     digitalWrite(pinLF,LOW);
     analogWrite(Lpwm_pin,speed_val);
     analogWrite(Rpwm_pin,speed_val);
     
      
    }

void go_backward(unsigned char speed_val)    // speed_val：0~255
    {
     digitalWrite(pinRB,LOW);  
     digitalWrite(pinRF,HIGH);
     digitalWrite(pinLB,LOW);  
     digitalWrite(pinLF,HIGH);
     analogWrite(Lpwm_pin,speed_val);
     analogWrite(Rpwm_pin,speed_val);
    }
    
void rotate_left(unsigned char speed_val)        // speed_val：0~255
    {digitalWrite(pinRB,HIGH);
     digitalWrite(pinRF,LOW );  
     digitalWrite(pinLB,LOW); 
     digitalWrite(pinLF,HIGH);
     analogWrite(Lpwm_pin,speed_val);
     analogWrite(Rpwm_pin,speed_val);
      
     
    }
void rotate_right(unsigned char speed_val)    // speed_val：0~255
    {
      digitalWrite(pinRB,LOW);  
     digitalWrite(pinRF,HIGH);
     digitalWrite(pinLB,HIGH);
     digitalWrite(pinLF,LOW);  
     analogWrite(Lpwm_pin,speed_val);
     analogWrite(Rpwm_pin,speed_val);
     
    }    
void stopp()        //stop
    {
     digitalWrite(pinRB,HIGH);
     digitalWrite(pinRF,HIGH);
     digitalWrite(pinLB,HIGH);
     digitalWrite(pinLF,HIGH);
    }

int step = 5;
int speed = 100;
int rot = 1;
int currstate = 0;
void loop() { 
    //read all the pixels
    amg.readPixels(pixels);

    //find the hottest pixel
    int maxid = 0;
    for(int i=1; i<=AMG88xx_PIXEL_ARRAY_SIZE; i++){
      if (pixels[i] > pixels[maxid]) {
        maxid=i;
      }
    }
    //calculate the column that the hot point is in
    int column = -(3.5-(maxid%8));
    Serial.println(pixels[maxid]);

    //reset if there are no hot pixels to be found
    if (pixels[maxid] < 0) {
      myservo.write(90);
      stopp();
    }
    else {

    //turn the servo left or right depending on the column of the hot point
    if (column > 0 && myservo.read() < 180-step) {
      myservo.write(myservo.read()+step);
      
    }
    else if (column < 0 && myservo.read() > step) {
      myservo.write(myservo.read()-step);

    }

    //Calculate the hot points angle relative to the front of the car
    //rather than the direction the servo is facing
    int truecolumn = column + (myservo.read()-90)*(4.0/90.0);
    
    //Turn left, turn right, or go forward depending on the position of the hot point
    if (truecolumn > 1) {
      if (currstate!=0) {
        stopp();
        delay(50);
      }
      rotate_left(speed*rot);
      currstate=0;
    }
    else if (truecolumn < -1) {
      if (currstate!=1) {
        stopp();
        delay(50);
      }
      rotate_right(speed*rot);
      currstate=1;
    }
    else {
      if (currstate!=2) {
        stopp();
        delay(50);
      }
      go_forward(speed);
      currstate=2;
    }
    }
    //delay a second
    delay(100);
}
